; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    szCmpixx PROTO :DWORD,:DWORD,:DWORD
    szCmpix  PROTO :DWORD,:DWORD,:DWORD
    szCmpix6 PROTO :DWORD,:DWORD,:DWORD

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL hmem  :DWORD
    LOCAL hbuf  :DWORD
    LOCAL flen  :DWORD
    LOCAL add1  :DWORD
    LOCAL add2  :DWORD
    LOCAL add3  :DWORD

    mov add1, 0
    mov add2, 0
    mov add3, 0

    invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_TIME_CRITICAL

    mov hmem, InputFile("\masm32\include\windows.inc")
    mov flen, ecx
    mov hbuf, alloc(flen)
    invoke MemCopy,hmem,hbuf,flen

    mov hmem, lcase$(hmem)
    mov hbuf, ucase$(hbuf)

    push edi
    mov edi, 8

  lp1:

  ; -------------------------------------------

    invoke GetTickCount
    push eax

    push esi
    mov esi, 30

  @@:
    invoke szCmpix,hmem,hbuf,flen
    sub esi, 1
    jnz @B

    pop esi

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add add1, eax

    print str$(eax)," MS szCmpix",13,10

  ; -------------------------------------------

    invoke GetTickCount
    push eax

    push esi
    mov esi, 30

  @@:
    invoke szCmpixx,hmem,hbuf,flen
    sub esi, 1
    jnz @B

    pop esi

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add add2, eax

    print str$(eax)," MS szCmpixx",13,10

  ; -------------------------------------------

    invoke GetTickCount
    push eax

    push esi
    mov esi, 30

  @@:
    invoke szCmpix6,hmem,hbuf,flen
    sub esi, 1
    jnz @B

    pop esi

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add add3, eax

    print str$(eax)," MS szCmpix6",13,10

  ; -------------------------------------------

    sub edi, 1
    jnz lp1

    invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_NORMAL

    shr add1, 3
    shr add2, 3
    shr add3, 3

    print chr$(13,10)
    print str$(add1)," MS average for szCmpix",13,10
    print str$(add2)," MS average for szCmpixx",13,10
    print str$(add3)," MS average for szCmpix6",13,10
    print chr$(13,10)

    free hmem
    free hbuf

    mov eax, input("Press ENTER to exit")

    ret

main endp

; 

; 

    .data
    align 16
      tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
    .code

; 

align 4

szCmpixx proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov esi, src
    mov edi, dst
    mov eax, -1

  align 4
  @@:
    add eax, 1
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    mov cl, [edx+tbl]
    cmp cl, [ebx+tbl]
    jne miss
    cmp eax, ln
    jne @B

    sub eax, eax
    jmp quit

  miss:
    add eax, 1

  quit:
    pop edi
    pop esi
    pop ebx

    ret

szCmpixx endp

; 

    .data
    align 16
    @_cmpi_table_@ \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
    .code

; 

align 4

szCmpix proc src:DWORD,dst:DWORD,ln:DWORD

  ; -----------------------------------------------------------
  ; algorithm compares any two byte sequences CASE INSENSITIVE
  ; and returns zero if they are identical or the character
  ; count where the two byte sequences mismatch.
  ; -----------------------------------------------------------

    push ebx
    push esi
    push edi

    sub eax, eax
    sub edx, edx

    mov ebx, OFFSET @_cmpi_table_@  ; table base address
    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln

    push ebp
    mov ebp, -1

  align 4
  @@:
    add ebp, 1
    mov al, [esi+ebp]               ; get 1st byte
    xlatb                           ; replace it with byte in table
    mov dl, al                      ; store it in DL
    mov al, [edi+ebp]               ; get 2nd byte
    xlatb                           ; replace it with byte in table
    sub al, dl                      ; if bytes are the same
    jnz @F                          ; exit the loop
    cmp ebp, ecx                    ; exit on length
    jl @B
  @@:

    mov ecx, ebp
    pop ebp

    cmp ecx, ln
    jnz @F
    xor eax, eax
    jmp quit
  @@:
    lea eax, [ecx+1]

  quit:

    pop edi
    pop esi
    pop ebx

    ret

szCmpix endp

; 

align 16
szCmpix6 proc src:DWORD,dst:DWORD,ln:DWORD

    xor eax, eax
	cmp ln,eax
	je	wrap 
	
    push esi
    push edi

    xor edx,edx

    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln
	align 16
@@:
    movzx eax, byte ptr [esi]               ; get 1st byte
    cmp eax,41h ;'A'
    jb noupper
    cmp eax,5ah ;'Z'
    ja noupper
    or eax,20h
    noupper:
    movzx edx, byte ptr [edi]               ; get 2nd byte
    cmp edx,41h ;'A'
    jb noupper2
    cmp edx,5ah ;'Z'
    ja noupper2
    or edx,20h
    noupper2:
    cmp eax, edx                    ; if bytes are the same
    jne done                          ; exit the loop

    sub ecx,1
    jz done2

    movzx eax, byte ptr [esi+1]               ; get 1st byte
    cmp eax,41h ;'A'
    jb noupper3
    cmp eax,5ah ;'Z'
    ja noupper3
    or eax,20h
    noupper3:
    movzx edx, byte ptr [edi+1]               ; get 2nd byte
    cmp edx,41h ;'A'
    jb noupper4
    cmp edx,5ah ;'Z'
    ja noupper4
    or edx,20h
    noupper4:
    cmp eax, edx                    ; if bytes are the same
    jne done                          ; exit the loop

	sub ecx,1    
    jz done2			; no more to do
    add esi,2
    add edi,2
    jmp @b

done2:	; here if out of characters to test, return zero
	xor eax,eax
	jmp quit

done:	; here if mismatch
	mov eax,ln
	sub eax,ecx
	add eax,1
	
quit:
    pop edi
    pop esi
wrap:
    ret

szCmpix6 endp

; 

end start
